"""
A program to sort student information into GPA order.
"""

from gpa_refactored import Student, make_student


def main():
    print('This program sorts student grade information by GPA.')
    filename = input('Enter the name of the data file: ')
    data = read_students(filename)
    data.sort(key=Student.calculate_gpa)
    filename = input('Enter a name for the output file: ')
    write_students(data, filename)
    print('The data has been written to', filename)


def read_students(filename):
    infile = open(filename, 'r')
    students = []
    for line in infile:
        students.append(make_student(line))
    infile.close()
    return students


def write_students(students, filename):
    outfile = open(filename, 'w')
    for student in students:
        print(f'{student.name}\t{student.hours}\t{student.quality_points}', file=outfile)
    outfile.close()


if __name__ == '__main__':
    main()
